package com.example.planovac_v1.app;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteException;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

/**
 * Created by marek on 7/29/14.
 */
public class adapter_dB {
    public static final String DATABASE_NAME = "planovac.db";
    public static final String DATABASE_TABLE = "ulohy";
    public static final int DATABASE_VERSION = 1;

    public static final String COLUMN_ID = "_id"; // standard, ktory treba dodrzat
    public static final String COLUMN_DATE = "datum";
    public static final int COLUMN_DATE_NUM = 1;
    public static final String COLUMN_TASK = "uloha";
    public static final int COLUMN_TASK_NUM = 2;

    private final Context context;

    public SQLiteDatabase db;

    private tbl_helper m_helper;

    // trieda pre vytvorenie novej dB (tabulky)
    private static class tbl_helper extends SQLiteOpenHelper {
        // SQL statement pre vytvorenie novej dB (tabulky)
        private static final String CREATE_DATABASE = "create table " +
                DATABASE_TABLE + " (" + COLUMN_ID +
                " integer primary key autoincrement, " +
                COLUMN_DATE + " long, " +
                COLUMN_TASK + " text not null);";

        // konstruktor pre pristup k dB (nie pre jej vytvorenie)
        public tbl_helper(Context context, String name,
                          SQLiteDatabase.CursorFactory factory, int version) {
            super(context, name, factory, version);
        }
        // vytvorenie novej dB (tabulky)
        @Override
        public void onCreate(SQLiteDatabase _db) {
            _db.execSQL(CREATE_DATABASE);
        }
        // aktualizacia verzie dB (tabulky)
        @Override
        public void onUpgrade(SQLiteDatabase _db, int _oldVersion, int _newVersion) {
            Log.w("adapter_dB", " Aktualizacia dB (tabulky) z verzie" +
                    _oldVersion + " na verziu " + _newVersion +
                    ", vsetky udaje v tabulke budu vymazane");
            // zrusenie povodnej dB (tabulky)
            _db.execSQL("DROP TABLE IF EXISTS " + DATABASE_TABLE);
            // vytvorenie novej dB (tabulky)
            onCreate(_db);
        }
    }

    // konstruktor
    public adapter_dB(Context _context) {
        this.context = _context;
        m_helper = new tbl_helper(context, DATABASE_NAME, null, DATABASE_VERSION);
    }
    // vytvorenie, alebo otvorenie dB v RO alebo RW mode
    public void open() throws SQLiteException {
        try {
            // vykona sa #onCreate, #onUpgrade and/or #onOpen
            db = m_helper.getWritableDatabase();
        } catch (SQLiteException ex) {
            db = m_helper.getReadableDatabase();
        }
    }
    // zatvorenie dB
    public void close() {
        db.close();
    }
    // pridanie noveho zaznamu
    public long pridaj_zaznam(polozka_zoznamu PZ) {
        // vytvorenie noveho riadku kluc/hodnota
        ContentValues riadok = new ContentValues();
        // priradenie udajov novemu riadku
        riadok.put(COLUMN_DATE, PZ.get_datum().getTime());
        riadok.put(COLUMN_TASK, PZ.get_uloha());
        // pridanie riadku do tabulky
        return db.insert(DATABASE_TABLE, null, riadok);
    }
    // vymazanie zaznamu z tabulky na zaklade znenia ulohy
    public boolean vymaz_zaznam(String U) {
        return db.delete(DATABASE_TABLE, COLUMN_TASK + "= \"" + U + "\"", null) > 0;
    }
    // vymazanie vsetkych zaznamov z tabulky
    public boolean vymaz_vsetky_zaznamy() {
        return db.delete(DATABASE_TABLE, null, null) > 0;
    }
    // kurzor na vsetky zaznamy
    public Cursor kurzor_na_vsetky_zaznamy() {
        // query - dbName, columnNames, whereClause, selectionArgs, groupBy, having, orderBy
        // null = all columns, all data, rows not grouped, no filter, no ordering
        return db.query(DATABASE_TABLE,
                new String[] { COLUMN_ID, COLUMN_DATE, COLUMN_TASK },
                null, null, null, null, null);
    }
}
